An abstract representation of file and directory pathnames.

version | $Id$
package | phing.system.io

### Methods

## constructor

    __construct($arg1, $arg2)

### Parameters

#### $arg1

#### $arg2

## Return string representation of the object

    __toString() : string

### Returns

`string`

## Enter description here .

    _slashify(\PhingFile | string $path, boolean $isDirectory) : string

..

### Parameters

#### $path

`\PhingFile` `string`

#### $isDirectory

`boolean`

### Returns

`string`

## Tests whether the application can read the file denoted by this abstract pathname.

    canRead() : boolean

### Returns

`boolean`true if and only if the file specified by this abstract pathname exists and can be read by the application; false otherwise

## Tests whether the application can modify to the file denoted by this abstract pathname.

    canWrite() : boolean

### Returns

`boolean`true if and only if the file system actually contains a file denoted by this abstract pathname and the application is allowed to write to the file; false otherwise.

## Compares two abstract pathnames lexicographically.

    compareTo(\PhingFile $file) : int

The ordering defined by this method depends upon the underlying system. On UNIX systems, alphabetic case is significant in comparing pathnames; on Win32 systems it is not.

### Parameters

#### $file

`\PhingFile`

Th file whose pathname sould be compared to the pathname of this file.

### Returns

`int`Zero if the argument is equal to this abstract pathname, a value less than zero if this abstract pathname is lexicographically less than the argument, or a value greater than zero if this abstract pathname is lexicographically greater than the argument

## Convenience method for returning the contents of this file as a string.

    contents() : string

This method uses file_get_contents() to read file in an optimized way.

### Exceptions

`\Exception` | - if file cannot be read

### Returns

`string`

## Simple-copies file denoted by this abstract pathname into another PhingFile

    copyTo(\PhingFile $destFile) : boolean

### Parameters

#### $destFile

`\PhingFile`

The new abstract pathname for the named file

### Returns

`boolean`true if and only if the renaming succeeded; false otherwise

## Atomically creates a new, empty file named by this abstract pathname if and only if a file with this name does not yet exist.

    createNewFile($parents, $mode) : boolean

The check for the existence of the file and the creation of the file if it does not exist are a single operation that is atomic with respect to all other filesystem activities that might affect the file.

### Parameters

#### $parents

#### $mode

### Exceptions

`\IOException` | if file can't be created

### Returns

`boolean`true if the named file does not exist and was successfully created; `false` if the named file already exists

## Static method that creates a unique filename whose name begins with $prefix and ends with $suffix in the directory $directory.

    createTempFile($prefix, $suffix, \PhingFile $directory) : \PhingFile

Static

$directory is a reference to a PhingFile Object. Then, the file is locked for exclusive reading/writing.

author | manuel holtgrewe, grin@gmx.net

### Parameters

#### $prefix

#### $suffix

#### $directory

### Exceptions

`\IOException` |

### Returns

`\PhingFile`

## Deletes the file or directory denoted by this abstract pathname.

    delete($recursive) : boolean

If this pathname denotes a directory, then the directory must be empty in order to be deleted.

### Parameters

#### $recursive

### Returns

`boolean`true if and only if the file or directory is successfully deleted; false otherwise

## Requests that the file or directory denoted by this abstract pathname be deleted when php terminates.

    deleteOnExit()

Deletion will be attempted only for normal termination of php and if and if only Phing::shutdown() is called.

Once deletion has been requested, it is not possible to cancel the request. This method should therefore be used with care.

## Tests this abstract pathname for equality with the given object.

    equals($obj) : boolean

Returns

    true

if and only if the argument is not

    null

and is an abstract pathname that denotes the same file or directory as this abstract pathname. Whether or not two abstract pathnames are equal depends upon the underlying system. On UNIX systems, alphabetic case is significant in comparing pathnames; on Win32 systems it is not.

### Parameters

#### $obj

### Returns

`boolean`

## Tests whether the file denoted by this abstract pathname exists.

    exists() : boolean

### Returns

`boolean`true if and only if the file denoted by this abstract pathname exists; false otherwise

## Returns the absolute form of this abstract pathname.

    getAbsoluteFile() : string

Equivalent to getAbsolutePath.

### Returns

`string`The absolute abstract pathname denoting the same file or directory as this abstract pathname

## Returns the absolute pathname string of this abstract pathname.

    getAbsolutePath() : string

If this abstract pathname is already absolute, then the pathname string is simply returned as if by the getPath method. If this abstract pathname is the empty abstract pathname then the pathname string of the current user directory, which is named by the system property user.dir, is returned. Otherwise this pathname is resolved in a system-dependent way. On UNIX systems, a relative pathname is made absolute by resolving it against the current user directory. On Win32 systems, a relative pathname is made absolute by resolving it against the current directory of the drive named by the pathname, if any; if not, it is resolved against the current user directory.

see | \global\#isAbsolute()

### Returns

`string`The absolute pathname string denoting the same file or directory as this abstract pathname

## Returns the canonical form of this abstract pathname.

    getCanonicalFile() : \PhingFile

Equivalent to getCanonicalPath(.

### Returns

`\PhingFile`The canonical pathname string denoting the same file or directory as this abstract pathname

## Returns the canonical pathname string of this abstract pathname.

    getCanonicalPath() : string

A canonical pathname is both absolute and unique. The precise definition of canonical form is system-dependent. This method first converts this pathname to absolute form if necessary, as if by invoking the getAbsolutePath() method, and then maps it to its unique form in a system-dependent way. This typically involves removing redundant names such as "." and .. from the pathname, resolving symbolic links (on UNIX platforms), and converting drive letters to a standard case (on Win32 platforms).

Every pathname that denotes an existing file or directory has a unique canonical form. Every pathname that denotes a nonexistent file or directory also has a unique canonical form. The canonical form of the pathname of a nonexistent file or directory may be different from the canonical form of the same pathname after the file or directory is created. Similarly, the canonical form of the pathname of an existing file or directory may be different from the canonical form of the same pathname after the file or directory is deleted.

### Returns

`string`The canonical pathname string denoting the same file or directory as this abstract pathname

## Retrieve the group of this file.

    getGroup() : int

### Returns

`int`User ID of the owner of this file.

## Returns the target of the symbolic link denoted by this abstract pathname

    getLinkTarget() : string

### Returns

`string`the target of the symbolic link denoted by this abstract pathname

## Retrieve the mode of this file.

    getMode() : int

### Returns

`int`

## Returns the name of the file or directory denoted by this abstract pathname.

    getName() : \The

This is just the last name in the pathname's name sequence. If the pathname's name sequence is empty, then the empty string is returned.

### Returns

`\The`name of the file or directory denoted by this abstract pathname, or the empty string if this pathname's name sequence is empty

## Returns the pathname string of this abstract pathname's parent, or null if this pathname does not name a parent directory.

    getParent() : \The

The parent of an abstract pathname consists of the pathname's prefix, if any, and each name in the pathname's name sequence except for the last. If the name sequence is empty then the pathname does not name a parent directory.

### Returns

`\The`pathname string of the parent directory named by this abstract pathname, or null if this pathname does not name a parent

## Returns the abstract pathname of this abstract pathname's parent, or null if this pathname does not name a parent directory.

    getParentFile() : \The

The parent of an abstract pathname consists of the pathname's prefix, if any, and each name in the pathname's name sequence except for the last. If the name sequence is empty then the pathname does not name a parent directory.

### Returns

`\The`abstract pathname of the parent directory named by this abstract pathname, or null if this pathname does not name a parent

## Converts this abstract pathname into a pathname string.

    getPath() : string

The resulting string uses the default name-separator character to separate the names in the name sequence.

### Returns

`string`The string form of this abstract pathname

## Returns path without leading basedir.

    getPathWithoutBase(string $basedir) : string

uses | \global\getPath()

### Parameters

#### $basedir

`string`

Base directory to strip

### Returns

`string`Path without basedir

## Returns the length of this abstract pathname's prefix.

    getPrefixLength() : int

### Returns

`int`

## Returns the path to the temp directory.

    getTempDir() : string

Static

### Returns

`string`

## Retrieve the owner of this file.

    getUser() : int

### Returns

`int`User ID of the owner of this file.

## Tests whether this abstract pathname is absolute.

    isAbsolute() : boolean

The definition of absolute pathname is system dependent. On UNIX systems, a pathname is absolute if its prefix is "/". On Win32 systems, a pathname is absolute if its prefix is a drive specifier followed by "\", or if its prefix is "\".

### Returns

`boolean`true if this abstract pathname is absolute, false otherwise

## Tests whether the file denoted by this abstract pathname is a directory.

    isDirectory() : boolean

### Returns

`boolean`true if and only if the file denoted by this abstract pathname exists and is a directory; false otherwise

## Tests whether the file denoted by this abstract pathname is a normal file.

    isFile() : boolean

A file is normal if it is not a directory and, in addition, satisfies other system-dependent criteria. Any non-directory file created by a Java application is guaranteed to be a normal file.

### Returns

`boolean`true if and only if the file denoted by this abstract pathname exists and is a normal file; false otherwise

## Tests whether the file named by this abstract pathname is a hidden file.

    isHidden() : boolean

The exact definition of hidden is system-dependent. On UNIX systems, a file is considered to be hidden if its name begins with a period character ('.'). On Win32 systems, a file is considered to be hidden if it has been marked as such in the filesystem. Currently there seems to be no way to dermine isHidden on Win file systems via PHP

### Returns

`boolean`true if and only if the file denoted by this abstract pathname is hidden according to the conventions of the underlying platform

## Tests whether the file denoted by this abstract pathname is a symbolic link.

    isLink() : boolean

### Returns

`boolean`true if and only if the file denoted by this abstract pathname exists and is a symbolic link; false otherwise

## Returns the time that the file denoted by this abstract pathname was last modified.

    lastModified() : int

### Returns

`int`An integer value representing the time the file was last modified, measured in milliseconds since the epoch (00:00:00 GMT, January 1, 1970), or 0 if the file does not exist or if an I/O error occurs

## Returns the length of the file denoted by this abstract pathname.

    length() : int

The return value is unspecified if this pathname denotes a directory.

### Returns

`int`The length, in bytes, of the file denoted by this abstract pathname, or 0 if the file does not exist

## Returns an array of strings naming the files and directories in the directory denoted by this abstract pathname.

    listDir($filter) : array

If this abstract pathname does not denote a directory, then this method returns null Otherwise an array of strings is returned, one for each file or directory in the directory. Names denoting the directory itself and the directory's parent directory are not included in the result. Each string is a file name rather than a complete path.

There is no guarantee that the name strings in the resulting array will appear in any specific order; they are not, in particular, guaranteed to appear in alphabetical order.

### Parameters

#### $filter

string

### Returns

`array`An array of strings naming the files and directories in the directory denoted by this abstract pathname. The array will be empty if the directory is empty. Returns null if this abstract pathname does not denote a directory, or if an I/O error occurs.

## Enter description here .

    listFiles(\PhingFile[] $filter)

..

### Parameters

#### $filter

`\PhingFile[]`

## List the available filesystem roots.

    listRoots() : array

A particular platform may support zero or more hierarchically-organized file systems. Each file system has a root directory from which all other files in that file system can be reached. Windows platforms, for example, have a root directory for each active drive; UNIX platforms have a single root directory, namely "/". The set of available filesystem roots is affected by various system-level operations such the insertion or ejection of removable media and the disconnecting or unmounting of physical or virtual disk drives.

This method returns an array of PhingFile objects that denote the root directories of the available filesystem roots. It is guaranteed that the canonical pathname of any file physically present on the local machine will begin with one of the roots returned by this method.

The canonical pathname of a file that resides on some other machine and is accessed via a remote-filesystem protocol such as SMB or NFS may or may not begin with one of the roots returned by this method. If the pathname of a remote file is syntactically indistinguishable from the pathname of a local file then it will begin with one of the roots returned by this method. Thus, for example, PhingFile objects denoting the root directories of the mapped network drives of a Windows platform will be returned by this method, while PhingFile objects containing UNC pathnames will not be returned by this method.

### Returns

`array`An array of PhingFile objects denoting the available filesystem roots, or null if the set of roots could not be determined. The array will be empty if there are no filesystem roots.

## Creates the directory named by this abstract pathname.

    mkdir($mode) : boolean

### Parameters

#### $mode

### Exceptions

`\IOException` |

### Returns

`boolean`true if and only if the directory was created; false otherwise

## Creates the directory named by this abstract pathname, including any necessary but nonexistent parent directories.

    mkdirs($mode) : boolean

Note that if this operation fails it may have succeeded in creating some of the necessary parent directories.

### Parameters

#### $mode

### Exceptions

`\IOException` |

### Returns

`boolean`true if and only if the directory was created, along with all necessary parent directories; false otherwise

## If necessary, $File the lock on $File is removed and then the file is deleted

    removeTempFile()

access | public

## Renames the file denoted by this abstract pathname.

    renameTo(\PhingFile $destFile) : boolean

### Parameters

#### $destFile

`\PhingFile`

The new abstract pathname for the named file

### Returns

`boolean`true if and only if the renaming succeeded; false otherwise

## Sets the group of the file.

    setGroup($group)

### Parameters

#### $group

## Sets the last-modified time of the file or directory named by this abstract pathname.

    setLastModified(int $time) : boolean

All platforms support file-modification times to the nearest second, but some provide more precision. The argument will be truncated to fit the supported precision. If the operation succeeds and no intervening operations on the file take place, then the next invocation of the lastModified method will return the (possibly truncated) time argument that was passed to this method.

### Parameters

#### $time

`int`

The new last-modified time, measured in milliseconds since the epoch (00:00:00 GMT, January 1, 1970)

### Returns

`boolean`true if and only if the operation succeeded; false otherwise

## Sets the mode of the file

    setMode(int $mode)

### Parameters

#### $mode

`int`

Ocatal mode.

## Marks the file or directory named by this abstract pathname so that only read operations are allowed.

    setReadOnly() : boolean

After invoking this method the file or directory is guaranteed not to change until it is either deleted or marked to allow write access. Whether or not a read-only file or directory may be deleted depends upon the underlying system.

### Returns

`boolean`true if and only if the operation succeeded; false otherwise

## Sets the owner of the file.

    setUser(mixed $user)

### Parameters

#### $user

`mixed`

User name or number.

## Backwards compatibility - @see __toString()

    toString() : string

### Returns

`string`

## Constructs a file: URI that represents this abstract pathname.

    toURI() : void

todo | Not implemented yet

## Converts this abstract pathname into a file: URL.

    toURL() : void

The exact form of the URL is system-dependent. If it can be determined that the file denoted by this abstract pathname is a directory, then the resulting URL will end with a slash.

Usage note: This method does not automatically escape characters that are illegal in URLs. It is recommended that new code convert an abstract pathname into a URL by first converting it into a URI, via the toURI() method, and then converting the URI into a URL via the URI::toURL()

todo | Not implemented yet

## Enter description here .

    _constructFileParentStringChild(\unknown_type $parent, \unknown_type $child)

..

### Parameters

#### $parent

`\unknown_type`

#### $child

`\unknown_type`

## Enter description here .

    _constructPathname(\unknown_type $pathname)

..

### Parameters

#### $pathname

`\unknown_type`

## Enter description here .

    _constructStringParentStringChild(\unknown_type $parent, \unknown_type $child)

..

### Parameters

#### $parent

`\unknown_type`

#### $child

`\unknown_type`

### Properties

##

    $pathSeparator

##

    $separator

##

    $path

A normalized pathname string uses the default name-separator character and does not contain any duplicate or redundant separators.

##

    $prefixLength : int